<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="公司名称" prop="compyId">
        <el-select v-model="queryParams.compyId" placeholder="请选择公司名称" @change="doCompyChange">
          <el-option v-for="it in compyOpts" :key="it.deptId" :label="it.deptName" :value="it.deptId" />
        </el-select>
      </el-form-item>
      <el-form-item label="项目名称" prop="defaultDeptId">
        <el-select v-model="queryParams.defaultDeptId" placeholder="请选择项目名称" @change="doPrjChange">
          <el-option v-for="it in prjOpts" :key="it.deptId" :label="it.deptName" :value="it.deptId" />
        </el-select>
      </el-form-item>
      <el-form-item label="资产类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择资产类型" clearable>
          <el-option v-for="dict in dict.type.sys_process_category" :key="dict.value" :label="dict.label"
            :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="资产名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入资产名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="资产单位" prop="unit">
        <el-input v-model="queryParams.unit" placeholder="请输入资产单位" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['base:assetsType:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['base:assetsType:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['base:assetsType:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['base:assetsType:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="assetsTypeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键" align="center" prop="id" width="55" />
      <el-table-column label="资产类型" align="center" prop="type" width="120">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_process_category" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="资产名称" align="left" prop="name">
        <template slot-scope="scope">
          <el-tag v-if="!scope.row.deptId" effect="dark" type="danger">系统</el-tag>
          <span style="margin-left:10px;"><span v-if="scope.row.parentId">{{scope.row.parentName +' > '}}</span>{{scope.row.name}}</span>
        </template>
      </el-table-column>
      <el-table-column label="资产单位" align="center" prop="unit" />
      <el-table-column label="是否启用" align="center">
        <template slot-scope="scope">
          <el-switch v-if="scope.row.deptId || !nonAdmin" v-model="scope.row.isDel" active-value="0" inactive-value="1"
            @change="setStatus(scope.row, $event)"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="160">
        <template slot-scope="scope">
          <template v-if="scope.row.deptId || !nonAdmin">
            <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['base:assetsType:edit']">修改</el-button>
            <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
              v-hasPermi="['base:assetsType:remove']">删除</el-button>
          </template>
          <template v-else>
            <el-button type="danger" link disabled>系统级不能修改</el-button>
          </template>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改物资类型对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body custom-class="assets-type-dialog" :close-on-click-modal="false"
             :close-on-press-escape="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="公司名称" v-if="nonAdmin">
          <el-input v-model="form.compName" disabled />
        </el-form-item>
        <el-form-item label="项目名称" v-if="nonAdmin">
          <el-input v-model="form.deptName" disabled />
        </el-form-item>
        <el-form-item label="资产类型" prop="type">
          <el-select v-model="form.type" placeholder="请选择资产类型" @change="doLvl1Change" style="width:100%">
            <el-option v-for="dict in dict.type.sys_process_category" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="父级分类" prop="parentId">
          <el-select v-model="form.parentId" placeholder="请选择父级分类" style="width:100%">
            <el-option v-for="item in parentTypeOptions" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="资产名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入资产名称" />
        </el-form-item>
        <el-form-item label="资产单位" prop="sunit" v-if="form.parentId">
          <el-input v-model="form.sunit" placeholder="请输入资产单位" />
        </el-form-item>
        <div class="div-unit" v-if="form.parentId">
          <el-tag v-for="(it, idx) in units" :class="{ 'is-selected': it.sel, 'is-del': it.del }" @close="doCloseTag(it, idx)"
            :closable="!it.sys" @click="doSelTag(it)" :key="idx">
            <i class="el-icon-check"></i>
            {{ it.text }}
          </el-tag>
        </div>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAssetsType, getAssetsType, delAssetsType, addAssetsType, updateAssetsType, listLevel2, findParentTypesByCategory } from "@/api/base/assetsType";
import { listDept } from '@/api/system/dept'
export default {
  name: "AssetsType",
  dicts: ['sys_process_category', 'sys_is_del'],
  data() {
    return {
      units: [],
      lvlDatas: [],
      deptOpts: [],
      compyOpts: [],
      prjOpts: [],
      lvl2Opts: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 物资类型表格数据
      assetsTypeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        parentId: 0,
        pageNum: 1,
        pageSize: 10,
        compyId: null,
        defaultDeptId: null,
        type: null,
        name: null,
        unit: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        type: [{ required: true, message: "资产类型不能为空", trigger: "change" }],
        name: [{ required: true, message: "资产名称不能为空", trigger: "blur" }]
      },
      parentTypeOptions:[],
      nonAdmin:true,
    };
  },
  created() {
    if(this.$store.getters.userId==1){
      this.nonAdmin = false
    }
    listDept().then(d => {
      this.deptOpts = d.data || [];
      this.compyOpts = this.deptOpts.filter(it => it.parentId == 100)
      if (this.compyOpts.length > 0) {
        this.queryParams.compyId = this.compyOpts[0].deptId;
        this.form.compName = this.compyOpts[0].deptName;
        this.prjOpts = this.deptOpts.filter(it => it.parentId == this.queryParams.compyId);
        if (this.prjOpts.length > 0) {
          this.queryParams.defaultDeptId = this.prjOpts[0].deptId;
          this.doPrjChange(this.queryParams.defaultDeptId)
          this.form.deptName = this.prjOpts[0].deptName;
          this.getList();
        }
      }
    });
    listLevel2().then(d => {
      this.lvlDatas = d.data;
    })

  },
  methods: {
    doCloseTag(tag) {
      if (tag.del) {
        tag.del = false
      } else {
        tag.sel = false
        tag.del = true
      }
    },
    doSelTag(tag) {
      if (tag.del) {
        return;
      }
      tag.sel = !tag.sel;
    },
    doLvl1Change(value) {
      // this.lvl2Opts = this.lvlDatas.filter(d => d.type == a);
      // if (this.lvl2Opts.length > 0) {
      //   this.form.parentId = this.lvl2Opts[0].id;
      // }
      this.form.parentId = null;
      findParentTypesByCategory(value).then(res =>{
        this.parentTypeOptions = res.data||[];
      });
    },
    doCompyChange(a) {
      let tmps = this.compyOpts.filter(d => d.deptId == a);
      this.form.compName = tmps.length > 0 ? tmps[0].deptName : "";
      this.prjOpts = this.deptOpts.filter(it => it.parentId == this.queryParams.compyId);
      if (this.prjOpts.length > 0) {
        this.queryParams.defaultDeptId = this.prjOpts[0].deptId;
        this.form.deptName = this.prjOpts[0].deptName;
      }
      this.handleQuery();
    },
    doPrjChange(a) {
      let tmps = this.prjOpts.filter(d => d.deptId == a);
      let unit = tmps.length > 0 ? tmps[0].unit || "" : "";
      unit = unit.split(",").filter(d => d).map(d => {
        return {
          text: d,
          sel: false,
          del: false,
          sys: false
        }
      });

      let sysUnit = "米,包,吨,千克,平方,立方,把,根,个,箱,卷,台,盘,套,桶,捆,床,件,块,片,瓶,双,付,个,辆,项,张,组".split(",").filter(d => d)
        .map(d => {
          return {
            text: d,
            sel: false,
            del: false,
            sys: true
          }
        })
      this.units = [...sysUnit, ...unit];
      this.form.deptName = tmps.length > 0 ? tmps[0].deptName : "";
    },
    /** 查询物资类型列表 */
    getList() {
      this.loading = true;
      listAssetsType(this.queryParams).then(response => {
        this.assetsTypeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        parentId: null,
        deptId: this.nonAdmin?this.queryParams.defaultDeptId:null,
        type: null,
        name: null,
        sunit: "",
        unit: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      let tmps = this.compyOpts.filter(d => d.deptId == this.queryParams.compyId);
      this.form.compName = tmps.length > 0 ? tmps[0].deptName : "";
      tmps = this.prjOpts.filter(d => d.deptId == this.form.deptId);
      this.form.deptName = tmps.length > 0 ? tmps[0].deptName : "";
      tmps = this.dict.type.sys_process_category
      // if (tmps.length > 0) {
      //   this.form.type = tmps[0].value;
      //   this.lvl2Opts = this.lvlDatas.filter(d => d.type == this.form.type);
      //   if (this.lvl2Opts.length > 0) {
      //     this.form.parentId = this.lvl2Opts[0].id;
      //   }
      // }
      this.resetForm("form");
      this.doPrjChange(this.queryParams.defaultDeptId)
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(sel) {
      let selection = sel.filter(d => d.deptId);
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加物资类型";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      if(row.unit){
        let tmps=row.unit.split(",").filter(d=>d);
        let uns=this.units.map(d=>d.text).join(",")
        tmps.forEach(it=>{
          if((","+uns+",").indexOf(","+it+",")==-1){
            this.units.push({
              text:it,
              del:false,
              sys:false
            })
          }
        });
        this.units.forEach(it=>{        
          it.sel=(","+row.unit+",").indexOf(","+it.text+",")>=0;
        });
      }
      getAssetsType(id).then(response => {
        this.form = {...response.data,sunit:''};
        this.open = true;
        this.title = "修改物资类型";
      });
      this.doLvl1Change(row.type);
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          let unit = (this.form.sunit + "," + this.units.filter(d => d.sel && !d.del).map(d => d.text).join(",")).split(",").filter(d => d).join(",");
          let cusUnit = Array.from(new Set((this.form.sunit + "," + this.units.filter(d => !d.sys && !d.del).map(d => d.text).join(",")).split(",").filter(d => d))).join(",");
          this.form.unit = unit + "|" + cusUnit;
          let deptId = this.queryParams.defaultDeptId;
          let tmps = this.prjOpts.filter(d => d.deptId == deptId);
          if (tmps.length > 0) {
            tmps[0].unit = cusUnit;
          }
          this.doPrjChange(deptId)
          if (this.form.id != null) {
            updateAssetsType(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAssetsType(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    //状态设置
    setStatus(row, val) {
      this.$confirm(`是否确认修改数据为${val == "0" ? "有效" : "无效"}？`, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          let param = {
            id: row.id,
            isDel: val,
          };
          updateAssetsType(param).then((response) => {
            this.$modal.msgSuccess("修改成功");
            this.getList();
          });
        })
        .catch(() => {
          // 取消时恢复原始开关状态
          if (val == "0") {
            row.isDel = "1";
          } else {
            row.isDel = "0";
          }
        });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除物资类型编号为"' + ids + '"的数据项？').then(function () {
        return delAssetsType(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('base/assetsType/export', {
        ...this.queryParams
      }, `assetsType_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style lang="scss">
.assets-type-dialog {
  .div-unit {
    .el-tag {
      margin-right: 4px;
      margin-bottom: 4px;
      cursor: pointer;
      position: relative;

      .el-icon-check {
        display: none;
      }

      &.is-del {
        position: unset;
        user-select: none;
        background-color: #ccc;
        color: #777;
        text-decoration: line-through;

        .el-tag__close {
          color: red;

          &:hover {
            background-color: red;
            color: #fff;
          }
        }
      }

      &.is-selected {
        .el-icon-check {
          display: inline-block;
          position: absolute;
          bottom: 0px;
          right: 0px;
          background: #ffba00;
          border-radius: 0px 0px 4px 0px;
          color: #fff;
        }
      }
    }
  }
}</style>